class OsmGuidepostsController < ApplicationController
  before_action :set_osm_guidepost, only: [:show, :edit, :update, :destroy]
  before_action :ensure_admin!

  # GET /osm_guideposts
  def index
    @osm_guideposts = OsmGuidepost.all
    # filtry
    @osm_guideposts = @osm_guideposts.search(params[:search]) unless params[:search].blank?

    # sorting
    @osm_guideposts = @osm_guideposts.order(:kctref).order('kctref IS NULL')
    # paginace
    @osm_guideposts = @osm_guideposts.page(params[:page])
#     raise @osm_guideposts.to_sql
  end

  # GET /osm_guideposts/1
  def show
  end

  # GET /osm_guideposts/new
  def new
    @osm_guidepost = OsmGuidepost.new
  end

  # GET /osm_guideposts/1/edit
  def edit
  end

  # POST /osm_guideposts
  def create
    @osm_guidepost = OsmGuidepost.new(osm_guidepost_params)

    if @osm_guidepost.save
      redirect_to @osm_guidepost, notice: 'Osm guidepost was successfully created.'
    else
      render action: 'new'
    end
  end

  # PATCH/PUT /osm_guideposts/1
  def update
    if @osm_guidepost.update(osm_guidepost_params)
      redirect_to @osm_guidepost, notice: 'Osm guidepost was successfully updated.'
    else
      render action: 'edit'
    end
  end

  # DELETE /osm_guideposts/1
  def destroy
    @osm_guidepost.destroy
    redirect_to osm_guideposts_url, notice: 'Osm guidepost was successfully destroyed.'
  end

  # reimports all osm_guideposts
  def reimport
    require 'open-uri'
    OsmGuidepost.all.each { |g| g.destroy }
    url = "http://overpass-api.de/api/interpreter?data=%5Bout%3Ajson%5D%3Barea%5B%22name%22%3D%22%C4%8Cesko%22%5D%3Bnode%5B%22information%22%3D%22guidepost%22%5D%28area%29%3Bout%20body%3B%0A"
    import_osm_data_from_json_string(open(url).read)
    flash.notice = 'All Guideposts successfully reiported from OSM'
    redirect_to :action=>:index
  end
  

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_osm_guidepost
      begin
        if params[:id].match /osmid-(\d*)/  # umožňuje použíte osmid-XXXX místo id v databázi
          @osm_guidepost = OsmGuidepost.find_by_osmid($1)
        else
          @osm_guidepost = OsmGuidepost.find(params[:id])
        end
      rescue ActiveRecord::RecordNotFound
        flash.alert = "Tento OSM guidepost není v databázi. Možná jde o starý odkaz a mezitím byla databáze reimportována."
        redirect_to :action=> :index
      end
    end
    
    def set_osm_trail
    end


    # Only allow a trusted parameter "white list" through.
    def osm_guidepost_params
      params.require(:osm_guidepost).permit(:nazev, :kctref, :lat, :lon, :osmid, :ele)
    end
    
        def guidepost_params
    end

end
